local TimeSinceLastUpdate = 0
local ButtonShown = false
local MessageSent = false

local GrowlerCheckCast
local GrowlerBtn_MouseDown
local GrowlerBtn_ResetPos
local GrowlerBtn_DragStop
local GrowlerBtn_SetMoveSave
local CreateButton
local GrowlerOptions_Okay
local GrowlerOptions_CancelorLoad
local CreateOptionsPanel
local Growler_Show
local Growler_Hide
local GrowlerUpdate
local GrowlerInitiateGlobals

GrowlerCheckCast = function(unit, spellName, rank, lineID, spellID)
	if not MessageSent and Growler_NotifyGroup and IsInGroup() and spellID == 2649 and (UnitPlayerOrPetInRaid(unit) or UnitPlayerOrPetInParty(unit)) then
		local groupType = "PARTY"
		if IsInRaid() then groupType = "RAID" end
		SendChatMessage("{{Growler alert :: A hunter in the group has not turned off growl -- Download the addon to help manage your pets.}}",groupType)
		MessageSent = true
	end
end

GrowlerBtn_MouseDown = function(self, btn)
	if btn == "RightButton" then
		GrowlerBtn_ResetPos()
	elseif btn == "MiddleButton" then
		if Growler_Movable then Growler_SavePos = true end		
		Growler_Movable = not Growler_Movable		
		GrowlerBtn_SetMoveSave()
	end
end
GrowlerBtn_ResetPos = function()
	if not Growler_SavePos then
		Growler_Btn:SetUserPlaced(false)
		Growler_Btn:SetMovable(false)
	end
	
	Growler_Btn:ClearAllPoints()
	Growler_Btn:SetPoint("CENTER",World,"CENTER",0,100)
	Growler_Btn:SetMovable(true)
end

GrowlerBtn_DragStop = function()
	Growler_Btn:StopMovingOrSizing()
	if not Growler_SavePos then Growler_Btn:SetUserPlaced(false) end
end

GrowlerBtn_SetMoveSave = function(enabled,save)
	if enabled ~= nil then Growler_Movable = enabled end
	if save ~= nil then Growler_SavePos = save end
	
	if Growler_SavePos or Growler_Movable then
		Growler_Btn:SetUserPlaced(Growler_SavePos)
	end
	if not Growler_SavePos then GrowlerBtn_ResetPos() end
	
	if Growler_Movable then
		Growler_Btn:RegisterForDrag("LeftButton")
		Growler_Btn:SetScript("OnDragStart", Growler_Btn.StartMoving)
		Growler_Btn:SetScript("OnDragStop", GrowlerBtn_DragStop)
	else
		Growler_Btn:SetScript("OnDragStart", nil)
		Growler_Btn:SetScript("OnDragStop", nil)
	end
end

CreateButton = function()
	local Growler_Btn = CreateFrame("Button", "Growler_Btn", UIParent, "SecureActionButtonTemplate")
	Growler_Btn:SetAttribute("type","macro")
	Growler_Btn:SetAttribute("macrotext","/petautocaston [@party1,noexists] Growl\n/petautocastoff [@party1,exists] Growl")
	Growler_Btn:SetSize(65,65)
	Growler_Btn:SetClampedToScreen(true)
	Growler_Btn:SetMovable(true)
	local _, _, icon_texture = GetSpellInfo(2649)
	local Growler_Texture = Growler_Btn:CreateTexture(nil,"BACKGROUND",nil,-6)
	Growler_Texture:SetTexture(icon_texture)
	Growler_Texture:SetAllPoints(Growler_Btn)
	Growler_Btn:SetNormalTexture(Growler_Texture)
	Growler_Btn:SetAlpha(0)
	Growler_Btn:SetScript("OnMouseDown",GrowlerBtn_MouseDown)
	GrowlerBtn_SetMoveSave()
end

GrowlerOptions_Okay = function()
	Growler_on = Growler.Options.GrowlerOn:GetChecked()
	Growler_PlaySound = Growler.Options.GrowlerSound:GetChecked()
	Growler_NonParty = Growler.Options.GrowlerNonParty:GetChecked()
	Growler_NotifyGroup = Growler.Options.GrowlerNotify:GetChecked()
	Growler_Movable = Growler.Options.GrowlerMovable:GetChecked()
	Growler_SavePos = Growler.Options.GrowlerSavePos:GetChecked()
	
	GrowlerBtn_SetMoveSave()
end

GrowlerOptions_CancelorLoad = function()
	Growler.Options.GrowlerOn:SetChecked(Growler_on)
	Growler.Options.GrowlerSound:SetChecked(Growler_PlaySound)
	Growler.Options.GrowlerNonParty:SetChecked(Growler_NonParty)
	Growler.Options.GrowlerNotify:SetChecked(Growler_NotifyGroup)
	Growler.Options.GrowlerMovable:SetChecked(Growler_Movable)
	Growler.Options.GrowlerSavePos:SetChecked(Growler_SavePos)
end

CreateOptionsPanel = function()
	Growler.Options = CreateFrame("FRAME", "GrowlerOptions", Growler)
	Growler.Options.name = "Growler"
	Growler.Options.okay = GrowlerOptions_Okay
	Growler.Options.cancel = GrowlerOptions_CancelorLoad
	Growler.Options.refresh = GrowlerOptions_CancelorLoad
	
	Growler.Options.GrowlerOn = CreateFrame("CheckButton", "GrowlerOptionsOn", Growler.Options, "ChatConfigCheckButtonTemplate")
	Growler.Options.GrowlerOn:SetPoint("TOPLEFT", 10, -10);
	getglobal(Growler.Options.GrowlerOn:GetName() .. 'Text'):SetText("Growler On");
	
	Growler.Options.GrowlerSound = CreateFrame("CheckButton", "GrowlerOptionsSound", Growler.Options, "ChatConfigCheckButtonTemplate")
	Growler.Options.GrowlerSound:SetPoint("TOPLEFT", 10, -35);
	getglobal(Growler.Options.GrowlerSound:GetName() .. 'Text'):SetText("Sound");
	
	Growler.Options.GrowlerNonParty = CreateFrame("CheckButton", "GrowlerOptionsNonParty", Growler.Options, "ChatConfigCheckButtonTemplate")
	Growler.Options.GrowlerNonParty:SetPoint("TOPLEFT", 10, -60);
	getglobal(Growler.Options.GrowlerNonParty:GetName() .. 'Text'):SetText("Alert when not in a group");
	
	Growler.Options.GrowlerNotify = CreateFrame("CheckButton", "GrowlerOptionsNotify", Growler.Options, "ChatConfigCheckButtonTemplate")
	Growler.Options.GrowlerNotify:SetPoint("TOPLEFT", 10, -85);
	getglobal(Growler.Options.GrowlerNotify:GetName() .. 'Text'):SetText("Notify group when someone uses growl");
	
	Growler.Options.GrowlerMovable = CreateFrame("CheckButton", "GrowlerOptionsMovable", Growler.Options, "ChatConfigCheckButtonTemplate")
	Growler.Options.GrowlerMovable:SetPoint("TOPLEFT", 10, -110);
	getglobal(Growler.Options.GrowlerMovable:GetName() .. 'Text'):SetText("Allows mouse dragging of the button to any position on the screen");
	
	Growler.Options.GrowlerSavePos = CreateFrame("CheckButton", "GrowlerOptionsSavePos", Growler.Options, "ChatConfigCheckButtonTemplate")
	Growler.Options.GrowlerSavePos:SetPoint("TOPLEFT", 30, -135);
	getglobal(Growler.Options.GrowlerSavePos:GetName() .. 'Text'):SetText("Save the position between sessions");
		
	InterfaceOptions_AddCategory(Growler.Options)	
	GrowlerOptions_CancelorLoad()
end


GrowlerShow = function()
	if not ButtonShown then
		Growler_Btn:SetAlpha(1)
		ActionButton_ShowOverlayGlow(Growler_Btn)
		if Growler_PlaySound then PlaySoundKitID(12867) end
		ButtonShown = true
	end
end

GrowlerHide = function()
	if ButtonShown then
		ActionButton_HideOverlayGlow(Growler_Btn)
		Growler_Btn:SetAlpha(0)
		if Growler_PlaySound then PlaySoundKitID(33338) end
		ButtonShown = false
	end
end

GrowlerUpdate = function(self, elapsed)
    TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
	
	if TimeSinceLastUpdate > 0.5 and Growler_on then
		TimeSinceLastUpdate = 0
		
		local autocastable, autostate = GetSpellAutocast("Growl")
		if Growler_NonParty then
			if ((IsInGroup() and autostate==true) or (not IsInGroup() and autostate==false)) then
				GrowlerShow()
			else
				GrowlerHide()
			end
		else
			if IsInGroup() and autostate==true then
				GrowlerShow()
			else
				GrowlerHide()
			end
		end
	elseif not Growler_on then
		GrowlerHide()
	end
end

GrowlerInitiateGlobals = function()
	if Growler_on == nil then Growler_on = true end	
	if Growler_PlaySound == nil then Growler_PlaySound = true end
	if Growler_NonParty == nil then Growler_NonParty = true end
	if Growler_NotifyGroup == nil then Growler_NotifyGroup = true end
	if Growler_Movable == nil then Growler_Movable = false end
	if Growler_SavePos == nil then Growler_SavePos = false end
end

function Growler_OnLoad(self, event,...)
    self:RegisterEvent("ADDON_LOADED")
end

function Growler_OnEvent(self, event, ...)	
	if event == "ADDON_LOADED" then
		if ... == "Growler" then
			self:UnregisterEvent("ADDON_LOADED")
			self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
			self:RegisterEvent("COMBAT_TEXT_UPDATE")
			self:SetScript("OnUpdate", GrowlerUpdate)
			GrowlerInitiateGlobals()
			CreateButton()
			CreateOptionsPanel()
		end
	elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
		GrowlerCheckCast(...)
	end
end